/* $Id: CoClassFactory.h 777 2006-04-27 10:39:53Z olau $ */

// Copyright (c) 2006 Caspar Gorvin, http://www.gorvin.de/
// Copyright (c) 2006 Heise Zeitschriften Verlag, http://www.heise.de/
// All rights reserved.

#pragma once

class CoClassFactory : public IClassFactory
{
public:
	CoClassFactory(void);
	virtual ~CoClassFactory(void);

	// Funktionen von IUnknown
	STDMETHODIMP QueryInterface(REFIID riid, void** ppvObject);
	STDMETHODIMP_(ULONG) AddRef();
	STDMETHODIMP_(ULONG) Release();

	// Funktionen von IClassFactory
	STDMETHODIMP LockServer(BOOL fLock);
	STDMETHODIMP CreateInstance(LPUNKNOWN pUnkOuter, REFIID riid, void** ppvObject);

private:
	// Anzahl von Client-Referenzen auf Objekte dieser Klasse
	int m_nRefCount;
};
